/**************************************************************************************
 Copyright (c) 2002 The UbixOS Project
 All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of conditions, the following disclaimer and the list of authors.
Redistributions in binary form must reproduce the above copyright notice, this list of conditions, the following disclaimer and the list of authors
in the documentation and/or other materials provided with the distribution. Neither the name of the UbixOS Project nor the names of its
contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 $Id: video.c,v 1.4 2003/04/23 21:42:34 reddawg Exp $

**************************************************************************************/

#include <sys/io.h>
#include <sys/video.h>
#include <ubixos/types.h>

unsigned char *videoBuffer = (char *)0xB8000;
int printColor = defaultColor;

void backSpace() {
  uInt32 bufferOffset = 0x0;
  outportByte(0x3d4, 0x0e);
  bufferOffset = inportByte(0x3d5);
  bufferOffset <<= 8; /* Shift Address Left 8 Bits */  
  outportByte(0x3d4, 0x0f);
  bufferOffset += inportByte(0x3d5);
  bufferOffset <<= 1; /* Shift Address Left 1 Bits */
  videoBuffer[bufferOffset--] = 0x0;
  videoBuffer[bufferOffset--] = 0x0;
  bufferOffset >>= 1;                     /* Set the new cursor position  */
  outportByte(0x3d4, 0x0f);
  outportByte(0x3d5, bufferOffset & 0x0ff);
  outportWord(0x3d4, 0x0e);
  outportByte(0x3d5, bufferOffset >> 8);
  return;
  }

void kprint(char *string) {
  unsigned int bufferOffset = 0,character = 0,i = 0;
  asm("cli");
  /* We Need To Get The Y Position */
  outportByte(0x3d4, 0x0e);
  bufferOffset = inportByte(0x3d5);
  bufferOffset <<= 8; /* Shift Address Left 8 Bits */
  /* Then We Need To Add The X Position */
  outportByte(0x3d4, 0x0f);
  bufferOffset += inportByte(0x3d5);
  bufferOffset <<= 1; /* Shift Address Left 1 Bits */
  while ((character=*string++)) {
    switch(character) {
      case '\n':
        bufferOffset = (bufferOffset/160)*160 + 160;
        break;
      default:
        videoBuffer[bufferOffset++] = character;
        videoBuffer[bufferOffset++] = printColor;
        break;
      }
    /* Check To See If We Are Out Of Bounds */
    if (bufferOffset >= 160*25) {
      for (i = 0; i < 160*24; i++) {
        videoBuffer[i] = videoBuffer[i+160];
        }
      for (i = 0; i < 80; i++) {
        videoBuffer[(160*24)+(i*2)] = 0x20;
        videoBuffer[(160*24)+(i*2)+1] = printColor;
        }
      bufferOffset -= 160;
      }
    }
  bufferOffset >>= 1;                     /* Set the new cursor position  */
  outportByte(0x3d4, 0x0f);
  outportByte(0x3d5, bufferOffset & 0x0ff);
  outportWord(0x3d4, 0x0e);
  outportByte(0x3d5, bufferOffset >> 8);
  asm("sti");
  }

/* Clears The Screen */
void clearScreen() {
  unsigned int i;
  for (i = 0; i < (80*25); i++) {         /* Fill the screen with         */
                                        /* background Color             */
    videoBuffer[i*2] = 0x20;
    videoBuffer[i*2+1] = defaultColor;
    }

  outportByte(0x3d4, 0x0f);                /* Set the cursor to the        */
  outportByte(0x3d5, 0);                   /* upper-left corner of the     */
  outportWord(0x3d4, 0x0e);                /* screen                       */
  outportByte(0x3d5, 0);
  }
